//+------------------------------------------------------------------+
//|                                                      RSI 2MA.mq4 |
//|                              Copyright  2005, Alejandro Galindo |
//|                                              http://elCactus.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Alejandro Galindo"
#property link      "http://elCactus.com"
//#property indicator_maximum 100
//#property indicator_minimum 0

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Gray
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_color4 LightGray
#property indicator_color5 LightGray
#property indicator_level1 80
#property indicator_level2 40
#property indicator_level3 50
#property indicator_level4 60
#property indicator_level5 20

extern int RSIperiod=14, MA1period=9, MA2period=45;
extern string TypeHelp = "SMA- 0, EMA - 1, SMMA - 2, LWMA- 3";
extern string TypeHelp2 = "John Hyden settings TypeMA1=0, TypeMA2=3";
extern int TypeMA1=0;
extern int TypeMA2=3;
//extern bool enableSoundAlert=false;
//extern bool enableEmailAlert=false;
double RSIBuffer[];
double MA1Buffer[];
double MA2Buffer[];
int    counted_bars=0;
bool AlertedShort=false;
bool AlertedLong=false;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorShortName("RSI 2MA");
/*   SetIndexDrawBegin(0,Bars);
   SetIndexDrawBegin(1,Bars);
   SetIndexDrawBegin(2,Bars);
   SetIndexDrawBegin(3,Bars);
   SetIndexDrawBegin(4,Bars);
*/
   SetIndexStyle(0,DRAW_LINE);   
   SetIndexBuffer(0,RSIBuffer);
   SetIndexLabel(0,"RSI "+RSIperiod);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,MA1Buffer);
   SetIndexLabel(1,"MA1 "+MA1period);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,MA2Buffer);
   SetIndexLabel(2,"MA2 "+MA2period);
  
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i,limit;      
   counted_bars=IndicatorCounted();
   
   if (Bars<=RSIperiod+MA1period+MA2period) return(0);
//---- 
   //---- check for possible errors
   if (counted_bars<0) return(-1);
   //---- last counted bar will be recounted
   if (counted_bars>0) counted_bars--;
   //----

   limit=Bars-counted_bars;

   for(i=0; i<limit; i++)
   {
      RSIBuffer[i]=iRSI(NULL,0,14,PRICE_CLOSE,i);      
   }
   for(i=0; i<limit; i++)
      MA1Buffer[i]=iMAOnArray(RSIBuffer,Bars,MA1period,0,TypeMA1,i);
   for(i=0; i<limit; i++)
      MA2Buffer[i]=iMAOnArray(MA1Buffer,Bars,MA2period,0,TypeMA2,i);
      
/*   
   // Alerts section
   if (!IsTesting() && Volume[0])
   {
   
      if (MA1Buffer[1]<=MA2Buffer[1] && MA1Buffer[0]>MA2Buffer[1] && !AlertedLong)
      {
         if (enableSoundAlert) Alert("LONG signal at Ask=",Ask,", Bid=",Bid,", Date=",TimeToStr(CurTime(),TIME_DATE)," ",TimeHour(CurTime()),":",TimeMinute(CurTime())," Symbol=",Symbol()," Period=",Period());
         if (enableEmailAlert) SendMail("LONG signal alert","LONG signal at Ask="+DoubleToStr(Ask,4)+", Bid="+DoubleToStr(Bid,4)+", Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());      
         AlertedLong=true;
         AlertedShort=false;
      }
      if (MA1Buffer[1]>=MA2Buffer[1] && MA1Buffer[0]<MA2Buffer[1] && !AlertedShort)
      {
         if (enableSoundAlert) Alert("SHORT signal at Ask=",Ask,", Bid=",Bid,", Date=",TimeToStr(CurTime(),TIME_DATE)," ",TimeHour(CurTime()),":",TimeMinute(CurTime())," Symbol=",Symbol()," Period=",Period());
         if (enableEmailAlert) SendMail("SHORT signal alert","SHORT signal at Ask="+DoubleToStr(Ask,4)+", Bid="+DoubleToStr(Bid,4)+", Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());      
         AlertedLong=false;
         AlertedShort=true;
      }

   }
*/   
//----
   return(0);
  }
//+------------------------------------------------------------------+

